//
// Created by lenfrex on 2022/4/4.
//

#include <cstring>
#include "CString.h"

/*
 * ոСʼַ
 */
CString::CString(int length) {
    data = new char[length]();
    CString::length = length;
}

CString::~CString() {
    delete[] data;
}

/*
 * 趨ʼСĬ512ַʼ
 */
CString::CString() : CString(512) {}

/*
 * صȺšJavaStringequal()ʵ֡
 * ȱȽַȣȲһ˵ֱӷfalsedataΪnullptrȽϲfalse
 * ͬĻٱȽַַָָǷһһʹָͬһڴ棬ֱӷtrue
 * ߶ͬŽֱȽ
 */
bool CString::operator==(const CString &source) const {
    // жCStringԼdataԱǷΪָ
    if (source.length != length || data == nullptr) {
        return false;
    } else {
        // жdataԱǷָͬһڴ
        if (source.data == data) {
            return true;
        }
    }

    // ʱŽֱȽ
    int compareLength = source.length < length ? source.length : length;
    for (int i = 0; i < compareLength; ++i) {
        if (data[i] != source.data[i]) {
            return false;
        }
    }
    return true;
}

/*
 * ԴиַµĶ
 */
CString::CString(char *source) : CString((int)strlen(source)) {
    strncpy(data, source, length);
}

/*
 * ԴиַµĶ󣬲ʼȣСԴַᱻȡ
 */
CString::CString(char *source, int length) : CString(length) {
    strncpy(data, source, length);
}

CString &CString::operator=(const CString &source) {
    // ԼԼֵǽɶԸֵ
    if (this == &source) {
        return *this;
    }

    if (data != nullptr && length != 0) {
        delete[] data;
    }

    this->length = source.length;
    this->data = new char[length]();

    strncpy(data, source.data, length);

    return *this;
}

CString &CString::operator+=(const CString &source) {
    if (data == nullptr && length == 0) {
        this->length = source.length;
        this->data = new char[length]();
    }

    char *tmp = new char[length]();
    strncpy(tmp, data, length);

    // ·ڴ棬ֹƴӺ
    delete[] data;
    this->length += source.length;
    this->data = new char[this->length];

    strcpy(tmp, data);
    strncat(data, source.data, source.length);

    return *this;
}

CString::CString(const CString &source) : CString(source.data, source.length) {}

/*
 * ֵ˳ֶԱ
 */
bool CString::operator<(const CString &source) const {
    // ⲿǰ==صǰж
    if (source.length != length || data == nullptr) {
        return false;
    } else {
        if (source.data == data) {
            return true;
        }
    }

    // ʱŽֱȽ
    int compareLength = source.length < length ? source.length : length;
    for (int i = 0; i < compareLength; ++i) {
        if (data[i] < source.data[i]) {
            return true;
        }
    }
    return false;
}
